<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>DFA To Regular Grammar</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070621;15145700">
	<META NAME="CHANGED" CONTENT="20070709;13001200">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Converting a DFA to a
Regular Grammar</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#introduction"><U>Introduction</U></A><A HREF="#blocks"><U><BR></U></A><A HREF="#convert"><U>Converting
to a Regular Grammar</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="introduction"></A>
Introduction</H2>
<P STYLE="margin-bottom: 0in">The reader, if he or she hasn't
already, should read the tutorial about <A HREF="../createfa/fa.html">creating
a finite automaton</A>, which covers the basics of constructing a FA
and describes how they are implemented in JFLAP. This section
specifically describes how one may transform one of these finite
automata into a right-linear grammar.</P>
<P STYLE="margin-bottom: 0in">To get started, open JFLAP. Then,
either load the file <A HREF="dfaToRegGrammar.jff">dfaToRegGrammar.jff</A>,
or construct the nondeterministic finite automaton present in the
screen below. When finished, your screen should look something like
this:</P>
<P ALIGN=CENTER><IMG SRC="images/intro" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><A NAME="convert"></A><FONT SIZE=5><B>Converting
to a Regular Grammar</B></FONT></P>
<P STYLE="margin-bottom: 0in; font-weight: medium"><FONT SIZE=3>We
will now convert this DFA into a regular grammar. Click on the
“Convert → Convert to Grammar” menu option, and this screen
should come up:</FONT></P>
<P ALIGN=CENTER><IMG SRC="images/introgrammar" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P STYLE="margin-bottom: 0in">Notice the labels on the states in the
picture. JFLAP, by default, assigns unique variables to each state.
Each transition in the graph corresponds with a production in a
right-linear grammar. For example, the transition from “q0” to
“q0” along the transition “a” matches the production “S →
aS”. Let's add this production to our list of productions in the
right panel. To add the production, just click on the “a”
transition on state “q0”. The “a” transition should now be
highlighted in red, and the production added to the right panel.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TH>
				<P><U>Highlighted Transition</U> 
				</P>
			</TH>
			<TH>
				<P><U>Corresponding Production</U></P>
			</TH>
		</TR>
		<TR>
			<TD>
				<P ALIGN=CENTER><IMG SRC="images/firsttransition" NAME="Graphic4" ALIGN=MIDDLE WIDTH=66 HEIGHT=102 BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/firstproduction" NAME="Graphic4" ALIGN=MIDDLE WIDTH=224 HEIGHT=34 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P STYLE="margin-bottom: 0in">Now, let's see what our next step might
be. We know it probably will be a transition in the FA, but if we are
having trouble, we can click on the “Hint” button, and one
production that we haven't generated yet will be generated. Now, how
many productions do we still need to generate. Click on the “What's
Left?” button to find out. We will see the remaining two
transitions highlighted, but we will also see state “q1”
highlighted. This is because any final state carries the production
to λ. Feel free to click on the rest of transitions and the final
state, or the “Show All” button, which will add the rest of the
productions to the graph. After finishing, the following should be
your list of productions (even if not exactly in that order):</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/finishedproductions" NAME="Graphic3" ALIGN=MIDDLE WIDTH=225 HEIGHT=82 BORDER=0></P>
<P STYLE="margin-bottom: 0in">When finished, click on the “Export”
button, and you should have a new grammar on the screen resembling
the screen below:</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/finalgrammar" NAME="Graphic5" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><B>This concludes our brief tutorial on
converting FAs into regular right-linear grammars. Thanks for
reading!</B></P>
</BODY>
</HTML>
